/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Geneticky_algoritmus;

import Funkce.Funkce;

/**
 *
 * @author Miraxp
 */
public class Geneticky_algoritmus {

    private short pocetJedincu, procentoPrezivsich;
    private short typVyberu;
    private double pravdepodobnostMutace, parPromennych[][];
    private Funkce funkce;

    public Geneticky_algoritmus(short nPocetJedincu, double nPravMutace, double nParPromennych[][], Funkce nFunkce, short nProcentoPrezivsich, short nTypVyberu) {
        pocetJedincu = nPocetJedincu;
        pravdepodobnostMutace = nPravMutace;
        parPromennych = nParPromennych;
        funkce = nFunkce;
        procentoPrezivsich = nProcentoPrezivsich;
        typVyberu = nTypVyberu;
    }

    public double[] provedAlgoritmus(int pocetCyklu) {
        int cyklus = 0;
        Generace generace = new Generace(pocetJedincu, parPromennych, pravdepodobnostMutace, funkce, procentoPrezivsich, typVyberu);
        while (cyklus < pocetCyklu) {
            cyklus++;
            generace = generace.vytvorGeneraciJednobodovymKrizenim();
        }
        return generace.dejPoleGenuNejlepsihoJedince();
    }
}
