/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * NewJFrame.java
 *
 * Created on 5.4.2011, 15:32:38
 */
package Graficka_aplikace;

import Optimalizace.Optimalizace;
import java.awt.BorderLayout;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.GroupLayout;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author Miraxp
 */
public class AplikaceJFrame extends javax.swing.JFrame {

    private JPanelGraf jPanelGraf;
    private JPanelLegenda jPanelLegenda;
    private JPanelGrafBilySum jPanelGrafBilySum;
    private JPanelLegendaBilySum jPanelLegendaBilySum;
    private JPanelNastaveni jPanelNastaveni;
    private JPanelVstup jPanelVstup;
    private JPanelVystup jPanelVystup;
    private boolean jeU, jeY, jeYGenetic, jeYNelder, jeYCtverce;

    /** Creates new form NewJFrame */
    public AplikaceJFrame() {
        initComponents();

        jeU = jeY = jeYGenetic = jeYNelder = jeYCtverce = false;

        this.jPanelLegenda = new JPanelLegenda(this);
        jPanelLegenda.aktualizujLegendu();

        this.jPanelLegendaBilySum = new JPanelLegendaBilySum(this);
        jPanelLegendaBilySum.aktualizujLegendu();

        this.jPanelNastaveni = new JPanelNastaveni();
        this.jPanelVstup = new JPanelVstup();
        jPanelVstup.setEditable(false);
        this.jPanelVystup = new JPanelVystup();
        jPanelVystup.setEditable(false);
        this.jPanelGraf = new JPanelGraf(jPanelVstup, jPanelVystup, jPanelLegenda);

        this.jPanelGrafBilySum = new JPanelGrafBilySum(jPanelVystup, jPanelLegendaBilySum);

        this.jPanelNastaveniMain.add(jPanelNastaveni);



        jScrollPaneVstup.setViewportView(jPanelVstup);
        jScrollPaneVystup.setViewportView(jPanelVystup);

        // This
        this.setSize(1100, 700);
        this.setLocation(50, 50);
        this.setTitle("Arma model");


        GroupLayout jPanelGrafLayout = new GroupLayout(jPanelGraf);
        jPanelGraf.setLayout(jPanelGrafLayout);
        jPanelGrafLayout.setHorizontalGroup(
                jPanelGrafLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 395, Short.MAX_VALUE));
        jPanelGrafLayout.setVerticalGroup(
                jPanelGrafLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 172, Short.MAX_VALUE));
        jPanelVizualizaceMain.add(jPanelGraf, BorderLayout.CENTER);


        GroupLayout jPanelLegendaLayout = new GroupLayout(jPanelLegenda);
        jPanelLegenda.setLayout(jPanelLegendaLayout);
        jPanelLegendaLayout.setHorizontalGroup(
                jPanelLegendaLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 395, Short.MAX_VALUE));
        jPanelLegendaLayout.setVerticalGroup(
                jPanelLegendaLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 100, Short.MAX_VALUE));
        jPanelVizualizaceMain.add(jPanelLegenda, BorderLayout.PAGE_END);


        GroupLayout jPanelGrafBilySumLayout = new GroupLayout(jPanelGrafBilySum);
        jPanelGrafBilySum.setLayout(jPanelGrafBilySumLayout);
        jPanelGrafBilySumLayout.setHorizontalGroup(
                jPanelGrafBilySumLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 395, Short.MAX_VALUE));
        jPanelGrafBilySumLayout.setVerticalGroup(
                jPanelGrafBilySumLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 172, Short.MAX_VALUE));
        jPanelVizualizaceBilySum.add(jPanelGrafBilySum, BorderLayout.CENTER);


        GroupLayout jPanelLegendaBilySumLayout = new GroupLayout(jPanelLegendaBilySum);
        jPanelLegendaBilySum.setLayout(jPanelLegendaBilySumLayout);
        jPanelLegendaBilySumLayout.setHorizontalGroup(
                jPanelLegendaBilySumLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 395, Short.MAX_VALUE));
        jPanelLegendaBilySumLayout.setVerticalGroup(
                jPanelLegendaBilySumLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGap(0, 100, Short.MAX_VALUE));
        jPanelVizualizaceBilySum.add(jPanelLegendaBilySum, BorderLayout.PAGE_END);

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane = new javax.swing.JTabbedPane();
        jPanelVizualizaceMain = new javax.swing.JPanel();
        jPanelNastaveniMain = new javax.swing.JPanel();
        jScrollPaneVstup = new javax.swing.JScrollPane();
        jScrollPaneVystup = new javax.swing.JScrollPane();
        jPanelVizualizaceBilySum = new javax.swing.JPanel();
        jPanelVolby = new javax.swing.JPanel();
        jButtonNactiData = new javax.swing.JButton();
        jButtonStart = new javax.swing.JButton();
        jButtonAktualizuj = new javax.swing.JButton();
        jButtonKonec = new javax.swing.JButton();
        jLabelAlgoritmus = new javax.swing.JLabel();
        jLabelCyklus = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanelVizualizaceMain.setLayout(new java.awt.BorderLayout());
        jTabbedPane.addTab("Vizualizace y, u", jPanelVizualizaceMain);

        jPanelNastaveniMain.setLayout(new java.awt.BorderLayout());
        jTabbedPane.addTab("Nastavení", jPanelNastaveniMain);
        jTabbedPane.addTab("Vstup", jScrollPaneVstup);
        jTabbedPane.addTab("Výstup", jScrollPaneVystup);

        jPanelVizualizaceBilySum.setLayout(new java.awt.BorderLayout());
        jTabbedPane.addTab("Vizualizace  ε", jPanelVizualizaceBilySum);

        jButtonNactiData.setText("Načti data");
        jButtonNactiData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNactiDataActionPerformed(evt);
            }
        });

        jButtonStart.setText("Start");
        jButtonStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStartActionPerformed(evt);
            }
        });

        jButtonAktualizuj.setText("Aktualizuj graf");
        jButtonAktualizuj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAktualizujActionPerformed(evt);
            }
        });

        jButtonKonec.setText("Konec");
        jButtonKonec.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonKonecActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelVolbyLayout = new javax.swing.GroupLayout(jPanelVolby);
        jPanelVolby.setLayout(jPanelVolbyLayout);
        jPanelVolbyLayout.setHorizontalGroup(
            jPanelVolbyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelVolbyLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButtonStart)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonNactiData)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonAktualizuj)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonKonec)
                .addContainerGap(15, Short.MAX_VALUE))
        );
        jPanelVolbyLayout.setVerticalGroup(
            jPanelVolbyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelVolbyLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelVolbyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonStart)
                    .addComponent(jButtonNactiData)
                    .addComponent(jButtonAktualizuj)
                    .addComponent(jButtonKonec))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanelVolby, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabelAlgoritmus)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelCyklus)
                .addContainerGap(266, Short.MAX_VALUE))
            .addComponent(jTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 625, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelAlgoritmus)
                            .addComponent(jLabelCyklus)))
                    .addComponent(jPanelVolby, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 284, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStartActionPerformed
        provedOptimalizaci();
}//GEN-LAST:event_jButtonStartActionPerformed

    private void jButtonNactiDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNactiDataActionPerformed
        try {
            FileReader soubor = nactiSoubor();
            if (soubor != null) {
                jPanelVystup.vymazVse();
                jPanelVystup.zobrazNadpis();
                jPanelVstup.nactiData(soubor);

                jeU = jeY = true;
                jeYGenetic = jeYNelder = jeYCtverce = false;

                jPanelLegenda.aktualizujLegendu();
                jPanelGraf.aktualizujGraf();
                repaint();
            }

        } catch (FileNotFoundException ex) {
            Logger.getLogger(AplikaceJFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(AplikaceJFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
}//GEN-LAST:event_jButtonNactiDataActionPerformed

    private void jButtonAktualizujActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAktualizujActionPerformed
        jPanelGraf.aktualizujGraf();
        repaint();
    }//GEN-LAST:event_jButtonAktualizujActionPerformed

    private void jButtonKonecActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonKonecActionPerformed
        System.exit(1);
    }//GEN-LAST:event_jButtonKonecActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new AplikaceJFrame().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAktualizuj;
    private javax.swing.JButton jButtonKonec;
    private javax.swing.JButton jButtonNactiData;
    private javax.swing.JButton jButtonStart;
    private javax.swing.JLabel jLabelAlgoritmus;
    private javax.swing.JLabel jLabelCyklus;
    private javax.swing.JPanel jPanelNastaveniMain;
    private javax.swing.JPanel jPanelVizualizaceBilySum;
    private javax.swing.JPanel jPanelVizualizaceMain;
    private javax.swing.JPanel jPanelVolby;
    private javax.swing.JScrollPane jScrollPaneVstup;
    private javax.swing.JScrollPane jScrollPaneVystup;
    private javax.swing.JTabbedPane jTabbedPane;
    // End of variables declaration//GEN-END:variables

    private FileReader nactiSoubor() throws FileNotFoundException, IOException {
        JFileChooser vyberSouboru = new JFileChooser();
        FileNameExtensionFilter filtr = new FileNameExtensionFilter("Formát txt", "txt");
        vyberSouboru.setFileFilter(filtr);
        int vysledek = vyberSouboru.showOpenDialog(this);
        if (vysledek == JFileChooser.APPROVE_OPTION) {
            return new FileReader(vyberSouboru.getSelectedFile().getAbsolutePath());
        } else {
            return null;
        }
    }

    private void provedOptimalizaci() {
        short rad = jPanelNastaveni.dejRad();
        if (jeU && jeY && jPanelVstup.dejPocetUdaju() > rad) {
            int pocetJedincu = jPanelNastaveni.dejPocetJedincu();
            double pravMutace = jPanelNastaveni.dejPravMutace();
            int max = jPanelNastaveni.dejMaximum();
            int min = jPanelNastaveni.dejMinimum();
            int presnost = jPanelNastaveni.dejPresnost();
            double parametryAlgoritmu[] = {pocetJedincu, pravMutace, min, max, presnost};
            short procentoPrezivsich = jPanelNastaveni.dejProcento();
            short typVyberu = jPanelNastaveni.typVyberu();

            double vstupniDataY[] = jPanelVstup.dejPoleDatY();

            Optimalizace optimalizace = new Optimalizace(vstupniDataY, jPanelVstup.dejPoleDatU(), rad, parametryAlgoritmu, procentoPrezivsich, typVyberu);

            int pocetCykluGen = jPanelNastaveni.dejPocetCykluGenetic();
            int pocetCykluNelder = jPanelNastaveni.dejPocetCykluNelder();

            jPanelVystup.vymazVse();
            jPanelVystup.nastavUdaje(jPanelVstup.dejPoleDatY(), jPanelVstup.dejPoleDatU(), rad * 2);


            if (jPanelNastaveni.dejChGenetic().isSelected()) {
                long startTimeGen = System.nanoTime();
                optimalizace.provedOptimalizaciGenetic(pocetCykluGen);
                long estimatedTimeGen = System.nanoTime() - startTimeGen;
                System.out.println("Doba výpočtu genetickým algoritmem: " + estimatedTimeGen + " ns");

                jPanelVystup.nastavParGenetic(optimalizace.dejVysledkyGenetic());
                jPanelVystup.nastavUdajeGenetic(optimalizace.dejVysledkyGenetic());
                jeYGenetic = true;
            } else {
                jeYGenetic = false;
            }
            if (jPanelNastaveni.dejChNelder().isSelected()) {
                long startTimeNel = System.nanoTime();
                optimalizace.provedOptimalizaciNelder(pocetCykluNelder);
                long estimatedTimeNel = System.nanoTime() - startTimeNel;
                System.out.println("Doba výpočtu algoritmem N-M: " + estimatedTimeNel + " ns");

                jPanelVystup.nastavParNelder(optimalizace.dejVysledkyNelderMead());
                jPanelVystup.nastavUdajeNelder(optimalizace.dejVysledkyNelderMead());
                jeYNelder = true;
            } else {
                jeYNelder = false;
            }
            if (jPanelNastaveni.dejChCtverce().isSelected()) {
                long startTimeCtv = System.nanoTime();
                optimalizace.provedOptimalizaciCtverce();
                long estimatedTimeCtv = System.nanoTime() - startTimeCtv;
                System.out.println("Doba výpočtu algoritmem NČ: " + estimatedTimeCtv + " ns");

                jPanelVystup.nastavParCtverce(optimalizace.dejVysledkyCtverce());
                jPanelVystup.nastavUdajeCtverce(optimalizace.dejVysledkyCtverce());
                jeYCtverce = true;
            } else {
                jeYCtverce = false;
            }

            jPanelVystup.zobrazNadpis();
            jPanelLegenda.aktualizujLegendu();
            jPanelGraf.aktualizujGraf();
            jPanelLegendaBilySum.aktualizujLegendu();
            jPanelGrafBilySum.aktualizujGraf(rad);
            repaint();
        }
    }

    public boolean nactenoY() {
        return jeY;
    }

    public boolean nactenoU() {
        return jeU;
    }

    public boolean nactenoYGenetic() {
        return jeYGenetic;
    }

    public boolean nactenoYNelder() {
        return jeYNelder;
    }

    public boolean nactenoYCtverce() {
        return jeYCtverce;
    }
}
