/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Metoda_nejmensich_ctvercu;

/**
 *
 * @author Miraxp
 */
public class Metoda_nejmensich_ctvercu {

    private double ymk[], u[];
    private Matice maticeY, maticeW, maticeWT, maticeWT_W, maticeWT_W_I, maticeWT_Y, matice_P;
    private int rad;
    private double vysledky[];

    public Metoda_nejmensich_ctvercu(double nYmk[], double nU[], int nRad) {
        this.u = nU;
        this.ymk = nYmk;
        this.rad = nRad;

        nastav_MaticiY();
        nastav_MaticiW();
    }

    public double[] provedAlgoritmus() {
        maticeWT = maticeW.dejTransponovanou();
        maticeWT_W = maticeWT.vynasob(maticeW);
        maticeWT_W_I = maticeWT_W.dejInverzni();
        maticeWT_Y = maticeWT.vynasob(maticeY);
        matice_P = maticeWT_W_I.vynasob(maticeWT_Y);
        nastavVysledky(matice_P.dejPrvky());
        return vysledky;
    }

    private void nastavVysledky(double vyslD[][]) {
        vysledky = new double[vyslD.length];
        for (int aktPar = 0; aktPar < vyslD.length; aktPar++) {
            if ((aktPar) % 2 != 0) {
                vysledky[aktPar] = -1 * vyslD[aktPar][0];
            } else {
                vysledky[aktPar] = vyslD[aktPar][0];
            }
        }
    }

    private void nastav_MaticiY() {
        int poc = ymk.length - rad;
        double prvkyY[][] = new double[poc][1];
        for (int aktPrvek = 0; aktPrvek < poc; aktPrvek++) {
            prvkyY[aktPrvek][0] = ymk[aktPrvek + rad];
        }
        maticeY = new Matice(prvkyY);
    }

    private void nastav_MaticiW() {
        int poc = ymk.length;
        double prvkyW[][] = new double[poc - rad][2 * rad];
        for (int aktPrvek = rad; aktPrvek < poc; aktPrvek++) {
            for (int aktRad = 0; aktRad < rad; aktRad++) {
                prvkyW[aktPrvek - rad][2 * aktRad] = ymk[aktPrvek - aktRad - 1];
                prvkyW[aktPrvek - rad][2 * aktRad + 1] = u[aktPrvek - aktRad - 1];
            }
        }
        maticeW = new Matice(prvkyW);
    }
}
